# THIS FILE IS AUTOMATICALLY GENERATED BY CARGO
#
# When uploading crates to the registry Cargo will automatically
# "normalize" Cargo.toml files for maximal compatibility
# with all versions of Cargo and also rewrite `path` dependencies
# to registry (e.g., crates.io) dependencies.
#
# If you are reading this file be aware that the original Cargo.toml
# will likely look very different (and much more reasonable).
# See Cargo.toml.orig for the original contents.

[package]
edition = "2024"
rust-version = "1.88"
name = "measured"
version = "0.0.25"
authors = ["Conrad Ludgate <conradludgate@gmail.com"]
build = false
autolib = false
autobins = false
autoexamples = false
autotests = false
autobenches = false
description = "A better way to measure your application statistics"
readme = "README.md"
license = "MIT OR Apache-2.0"
repository = "https://github.com/conradludgate/measured"
resolver = "2"

[package.metadata.docs.rs]
all-features = true
rustdoc-args = [
    "--cfg",
    "docsrs",
]

[features]
default = []
indexmap = ["dep:indexmap"]
lasso = ["dep:lasso"]
paracord = ["dep:paracord"]
phf = ["dep:phf"]

[lib]
name = "measured"
path = "src/lib.rs"

[[test]]
name = "comparisons"
path = "tests/comparisons.rs"

[[test]]
name = "histograms"
path = "tests/histograms.rs"

[[bench]]
name = "counters"
path = "benches/counters.rs"
harness = false
required-features = ["lasso"]

[[bench]]
name = "encoding"
path = "benches/encoding.rs"
harness = false
required-features = ["paracord"]

[[bench]]
name = "high_cardinality"
path = "benches/high_cardinality.rs"
harness = false
required-features = [
    "lasso",
    "paracord",
]

[[bench]]
name = "histograms"
path = "benches/histograms.rs"
harness = false
required-features = ["lasso"]

[[bench]]
name = "memory"
path = "benches/memory.rs"
harness = false
required-features = ["paracord"]

[dependencies.bytes]
version = "1"

[dependencies.crossbeam-utils]
version = "0.8.0"

[dependencies.hashbrown]
version = "0.15"

[dependencies.indexmap]
version = "2"
optional = true

[dependencies.itoa]
version = "1"

[dependencies.lasso]
version = "0.7"
features = ["multi-threaded"]
optional = true

[dependencies.measured-derive]
version = "0.0.25"

[dependencies.memchr]
version = "2"

[dependencies.paracord]
version = "0.1"
optional = true

[dependencies.parking_lot]
version = "0.12"

[dependencies.phf]
version = "0.13.1"
optional = true

[dependencies.rustc-hash]
version = "2"

[dependencies.ryu]
version = "1"

[dependencies.serde]
version = "1"

[dev-dependencies.ahash]
version = "0.8"

[dev-dependencies.divan]
version = "0.1.14"

[dev-dependencies.fake]
version = "4.3.0"

[dev-dependencies.metrics]
version = "0.24.2"

[dev-dependencies.metrics-exporter-prometheus]
version = "0.17.2"
default-features = false

[dev-dependencies.phf]
version = "0.13.1"
features = ["macros"]

[dev-dependencies.prometheus]
version = "0.14.0"
default-features = false

[dev-dependencies.prometheus-client]
version = "0.24.0"

[dev-dependencies.rand]
version = "0.9.2"
features = ["small_rng"]
